#pragma	ident	"@(#)nf_conf.c 1.1     94/07/05 NPI"
/*
 * 	Copyright (c) 1991,1992 by Network Peripherals Inc. 
 * 			All rights reserved.
 */

#include <sys/param.h>
#include <sys/buf.h>
#include <sys/file.h>
#include <sys/dir.h>
#include <sys/user.h>
#include <sys/uio.h>
#include <sys/mbuf.h>
#include <sys/sockio.h>
#include <machine/psl.h>
#include <machine/cpu.h>
#include <machine/mmu.h>
#include <sundev/mbvar.h>
#include <sys/types.h>
#include <sys/socket.h> 
#include <net/if.h>
#include <net/if_arp.h>
#include <net/netisr.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/if_ether.h>
#include <netinet/in_var.h>

/*#include "nf.h"	/* as generated by config */
/*#include "smt.h"	/* as generated by config */

int	nf_fbs = 0;
int	nf_txbc = 0;
int	nf_anb = 16;


/***  Set the MTU size do be used on the local FDDI net.
 ***/

int	nf_mtu = 4352;	/* MTU recommended in RFC 1188 */
/* int	nf_mtu = 4178;	/* MTU for communication with Netware stations */
/* int	nf_mtu = 1500; /* MTU for bridging to NFS clients on Ethernet */

int	nf_ip_frag = 0;    	/* No IP fragmentation */
/* int	nf_ip_frag = -1;	/* Fragment bridged frames to Enet MTU */


/***  Set the default Treq value in microseconds.  This value will
 ***     always be used following an interface reset.  The value should
 ***     always be between 4000 and 165000 microseconds.  The station
 ***     with the lowest Treq sets the operational token rotation time
 ***     for the entire network.  Optimum utilization of the FDDI
 ***     bandwidth is achieved with a token rotation time of around
 ***     8000 microseconds.
 ***/

int	nf_treq = 8000;

int	nf_T_Notify = 5;

/***  Set the nf_local_mac_address flag to 0 to force the FDDI
 ***    to use the host motherboard ethernet address.
 ***/

/* int	nf_local_mac_address = -1; 	/* Use local address */
int	nf_local_mac_address = 0;	/* Use host address */

/***  Set the number of 4KByte pages reserved for receive buffers.
 ***     If too many pages are taken, it may starve other processes.
 ***     Starved processes do not always behave nicely.  They have
 ***     been known to hang during boot, or prevent keyboard input.
 ***/
int	nf_num_llc_rx, nf_num_smt_rx;
nf_set_num_rx(num_cards)
	int num_cards;
{
	if (num_cards == 1) {
		nf_num_llc_rx = 48;
		nf_num_smt_rx = 4;
	} else {
		nf_num_llc_rx = 32;
		nf_num_smt_rx = 4;
	}
}

int	nf_num_tx = 8;
int	nf_num_copy = 4;

int	nf_mbuf_limit = 1024;

int 	nf_nit = -1;    	/* Enable Network Interface Tap */
/* int 	nf_nit = 0;    	/* Disable Network Interface Tap */

int	nf_copy_stale_NSA = 0;	/* Don't copy NSA with Aind set */
/* int	nf_copy_stale_NSA = -1;	/* Copy NSA with Aind set */

nf_hat_pagecache( addr, n)
	caddr_t addr;
	int n;
{
#if defined(SUN4M_35)
	(void)hat_pagecache(addr, n);
#endif
}
