/*
 *
 * Copyright 1994 Sun Microsystems, Inc. All Rights Reserved
 * ident "@(#)sender.c 1.2 94/04/06 Copyright 06 Apr 1994 SMI"
 *
 * 
 */
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define PORT 		5550 
#define DEF_TCP_BUF     32      /* Kytes: TCP buffer size */
extern char *optarg;
extern int optind, opterr, optopt;
extern int errno;

void usage ();

main(argc,argv)
int argc;
char **argv;
{
	struct sockaddr_in 	sin ;
	int 			sock  ;
	char 			*data_buf;
	long 			tcp_buf_size = DEF_TCP_BUF * 1024;
 	int  			i ;
	int  			new  ;
	int			on  = 1  ;
	int			n;
	int 			error ;
	int 			c ;
	long			tobesent=0;	/* Kbytes */



        /*
	 * Parse command line 
	 */
         while ((c = getopt(argc, argv, "b:")) != EOF)
               switch (c) {
               case 'b':
                    tcp_buf_size =atoi(optarg) * 1024 ;
                    break;
               default:
                    usage(argv[0]);
                    break;
          }
        if ( argc - optind != 1) {
                usage(argv[0]);
        }
	tobesent=atoi(argv[optind]); 

	/*
	 * Get a socket
	 */
	bzero((char *)&sin,sizeof(struct sockaddr_in));

	sock = socket(AF_INET, SOCK_STREAM, 0);
	if (sock == -1) {
		perror("	***socket");
		exit(1);
		}

        if (setsockopt(sock,SOL_SOCKET,SO_REUSEADDR,(char *)&on,sizeof(on)) < 0 ) {
                perror("        ***setsockopt");
                exit(2); 
                }
 
	/*
	 * Initialize buffer
	 */

        data_buf = (char *) calloc (tcp_buf_size,sizeof(char));
        if (data_buf == NULL) {
                perror("        ***calloc");
                exit(1);
                }
        for (i = 0 ; i < tcp_buf_size ; i++)
                data_buf[i] = 'a' ;

	/*
	 * Tell what's going to happen
	 */
	n = tobesent * 1024 / tcp_buf_size ; /* How many buffer I have to send */

        (void)printf("TEST: Sending %5d buffers of %d bytes on port %d\n",n,tcp_buf_size,PORT);
	(void)printf("      Total Kbytes to be sent: %d \n", tobesent);
        (void)printf("      TCP sending buffer: %5d bytes\n",tcp_buf_size);
  
	/* 
	 * Set the TCP sending buffer 
	 */
        if (setsockopt(sock,SOL_SOCKET,SO_SNDBUF,
		       (char *)&tcp_buf_size,sizeof(int)) < 0) {
                perror("        ***setsockopt");
                exit(4);
                }

	/*
	 * Bind
	 */
	sin.sin_family  = AF_INET ;
	sin.sin_addr.s_addr = INADDR_ANY ;
	sin.sin_port   = htons(PORT);

	error = bind(sock, (struct sockaddr *)&sin,sizeof(struct sockaddr_in));
	if (error < 0) {
		perror("	***bind");
		exit(3);
		}
	(void)printf("bind OK \n");

	/* 
	 * Listen
	 */
        error =	listen(sock,3);
	if (error < 0) {
		perror("	***listen");
		exit(4);
		}
	(void)printf("listen OK\n");

	/*
	 * Accept : wait for the peer
	 */
	new = accept(sock, NULL, NULL);
	if (new < 0) {
		perror("	***accept");
		exit(5);
		}
	(void)printf("accept OK\n");

	/*
	 * Loop: send data
	 */
	(void)printf("Start sending data ...\n");
	for (i = 0 ; i < n ; i++)
		{	
		error = send(new,(char *) data_buf,tcp_buf_size,0) ;
		if (error < 0) {
			perror("	***send");
			exit(6);
			}	
		/* putchar('.');
	           fflush(stdout);
	         */
		}
	(void)printf("All data sent successfully \n");
	return(0);

}
void
usage (name )
char  *name;
 {
        (void)fprintf(stderr,"Usage: %s [-b <BUF SIZE> ] KBytes \n",name);
        (void)fprintf(stderr,"\t-b <Kbytes>: Set the size of the TCP buffer used to send data \n");
        (void)fprintf(stderr,"\tKbytes:      to be sent to the receiver \n");
        exit (1);
}


